;+
;VERSION:
;  $LastChangedBy: bckerr $
;  $LastChangedDate: 2008-04-25 16:57:55 -0700 (Fri, 25 Apr 2008) $
;  $LastChangedRevision: 2821 $
;  $URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/tags/tdas_4_01/idl/themis/spacecraft/particles/SST/thm_sst_psef.pro $
;-

function thm_sst_psef,time,index=index,probe=probe,times=times,mask=mask,$
                      bins2mask=bins2mask

data_cache,'th'+probe+'_sst_raw_data',data,/get

if not keyword_set(data) then begin
   dprint,dlevel=0,'No data loaded for ',probe
   return,0
endif

if keyword_set(times) then return, *data.sef_064_time

dptr = data.sef_064_data
dim = size(/dimension,*dptr)
dist = thm_sst_dist3d_16x64(/elec)

dist.project_name = 'THEMIS'
dist.data_name = 'SST Electron Full distribution'
dist.magf = !values.f_nan

if n_elements(index) eq 0 then begin
    if n_elements(time) eq 0 then   ctime,time,npoints=1
    index=round( interp(dindgen(dim[0]),*data.sef_064_time,time) )
endif

dprint,dlevel=5,index

dist.index = index
dist.time = (*data.sef_064_time)[index]
dist.end_time = dist.time+3
dist.data= thm_part_decomp16((*data.sef_064_data)[index,*,*])
dist.cnfg= (*data.sef_064_cnfg)[index]
dist.atten = (*data.sef_064_atten)[index]
dist.units_name='Counts'
dist.valid=1
dist.mass = 0.511e6/(2.9979e5)^2
dist.bins[12:15,*] = 0
if keyword_set(mask) then begin
   bad_ang = [0,16,32,48] ; default masking created by Davin
   if keyword_set(bins2mask) then begin
      bad_ang = bins2mask
      if array_equal(bins2mask, -1) then begin
         print,''
         dprint,'WARNING: bins2mask array is empty. No bins masked for ', $
                         'th'+probe,'_psef data.'
         print,''
      endif else begin
         dist.bins[*,bad_ang]=!values.f_nan
      endelse
   endif
endif

return,dist
end
